#include "stdio.h"

/*
in/der vstupni a odvozene pole. Maximalne 26 pismen (A-Z), 100 zaznamu (radek) na skupinu.
Kazdy zaznam je ukoncen 0
*/

typedef char row[100][27];
row in, der;
int nfd; // pocet funkcnich zavislosti ve skupine

void merge(char row1,char row2);
int solve(int n);
void init(int n);

/* matice zavislosti - odvod
kazde pismeno A-Z (0-26) lze odvodit pomoci 0-99 funkcnich zavislosti
100. misto - pocet funkcnich zavislosti, ze kterych se odvozuje
na 26. radce, pokud lze, jsou nakonci poradova cisla funkcich zavislosti, ze kterych lze soucasnou odvodit
*/

char odvod[27][101];

int main(int argc, char *argv[]) {
  char c;
  int n, i, empty;
  int x = 1;
  FILE *f;

  if(argc < 2) {
    printf("You must supply a file");
    getc(stdin);
    return 0;
  }
  if(!(f = fopen(argv[1],"rt"))) {
    printf("Can not open file %s", argv[1]);
    getc(stdin);
    return 0;
  }
  printf("File %s opened\n", argv[1]);
  do {
    // pocet funkcnich zavislosti ve skupine
    fscanf(f, "%i", &nfd);
	 // cti funkcni zavislosti
    for(n = 0; n < nfd; n++) {
      c = getc(f); // nacte pismeno
      i = 0;
	   // vstupni podminky
      while(c != '-') {
        if((c >= 'A') && (c <= 'Z')) {
          in[n][i] = c - '@';
          i++; // preved do ciselne formy - musi odpovidat poradi v matici odvod
        }
        c = getc(f);
      }
      in[n][i] = 0;
      i = 0;
	 	// odvozene
      while(c != '\n') {
        if((c >= 'A') && (c <= 'Z')) {
          der[n][i] = c - '@';
          i++;
        }
        c = getc(f);
      }
      der[n][i] = 0;
    }
    if(nfd != 0) {
	 // Pro kazdou funkcni zavislost zjisti, zda ji lze odvodit
      printf("Set number %i\n", x);
      x++;
      empty = 0;
      for(n = 0; n < nfd; n++) {
        empty += solve(n);
      }
      if(empty == 0)
        printf("No redundant FDs.");
      printf("\n");
    }
  } while(nfd != 0);
  fclose(f);
  return 1;
}

// urci, zda FD s poradovym cislem n lze odvodit z ostatnich
int solve(int n) {
  int i, j, k, again, can;
  char row1, row2;
  init(n);

  j = 0; // j = ukazovatko na FD
// projdi vsechny FD, zjisti odvozeni, dokud takove existuje
  do {
    again = 2;
    if(j != n) { // vynech aktualni radku
      can = 1;
// projdi vsechny vstupni podminky
      for(i = 0; in[j][i]; i++)
        if(!(odvod[in[j][i] - 1][100]))
          can = 0; // existuje pismeno, ktere neni odvoditelne
      if(can) {
		  // vsechny se daji odvodit
        for(i = 0; der[j][i]; i++) {
          row2 = der[j][i] - 1;
          if(!(odvod[row2][100])) {
			 // Zkopiruj tabulku z jiz odvozenych, do nove odvoditelnych
            for(k = 0; in[j][k]; k++) {
              row1 = in[j][k]-1;
              merge(row2, row1);
            }
            odvod[row2][odvod[row2][100]] = j;
            odvod[row2][100]++;
            again = 1;
          }
        }
      }
    }
    j++;
    if(again == 1)
      j = 0;
    if((j == nfd) && (again == 2))
    	again = 0;
  } while(again);

// zapis na 26. radku posloupnosti odvozeni
  can = 1;
  for(i = 0; der[n][i]; i++) {
    if(!(odvod[der[n][i] - 1][100]))
      can = 0; // nektere pismeno nelze odvodit
    merge(26, der[n][i] - 1);
  }
  if(can) {
// Vsechny pismena lze odvodit
    printf(" FD %i is redundant using FDs:", n + 1);
    for(i = 0; i < odvod[26][100]; i++) {
      if(odvod[26][i] == n)
        continue; // to se tam objevi kvuli inicializaci
      printf(" %i", odvod[26][i] + 1);
    }
    printf("\n");
    return 1;
  }
  return 0; // nelze odvodit
}

void init(int n) {
  int i;
// vymaz odvozovaci matici
  for(i = 0; i < 27; i++)
    odvod[i][100] = 0;
// nastav vstupni podminky
  for(i = 0; in[n][i]; i++) {
    odvod[in[n][i] - 1][0] = n; // vstupni pismena aktulane testovane radky z ni lze odvodit
    odvod[in[n][i] - 1][100] = 1;
  }
}

// slouci dve odvozene rady s vynechanim stejnych FD
void merge(char row1, char row2) {
  int i, j, in;
  for(i = 0; i < odvod[row2][100]; i++) {
    in = 0;
    for(j = 0; j < odvod[row1][100]; j++)
      if(odvod[row1][j] == odvod[row2][i])
        in = 1; // je i-te pismeno row2 v row1?
    if(!in) {
      // ne, tak ho dej na konec row1
      odvod[row1][j] = odvod[row2][i];
      odvod[row1][100]++;
    }
  }
}
